// @flow

declare class TextBuffer$Range {
  static deserialize(array: [TextBuffer$Point, TextBuffer$Point]): this;
  static fromObject(object: TextBuffer$RangeLike, copy?: boolean): this;
  constructor(pointA: TextBuffer$PointLike, pointB: TextBuffer$PointLike): this;
  end: TextBuffer$Point;
  start: TextBuffer$Point;
  compare(other: TextBuffer$RangeLike): TextBuffer$Comparison;
  containsPoint(other: TextBuffer$PointLike, exclusive?: boolean): boolean;
  containsRange(other: TextBuffer$RangeLike, exclusive?: boolean): boolean;
  copy(): this;
  coversSameRows(other: TextBuffer$RangeLike): boolean;
  freeze(): this;
  getRowCount(): number;
  getRows(): number[];
  intersectsWith(other: TextBuffer$RangeLike, exclusive?: boolean): boolean;
  intersectsRow(row: number): boolean;
  intersectsRowRange(startRow: number, endRow: number): boolean;
  isEqual(other: TextBuffer$RangeLike): boolean;
  isEmpty(): boolean;
  isSingleLine(): boolean;
  negate(): this;
  serialize(): TextBuffer$RangeCompatible;
  toString(): string;
  translate(startDelta: TextBuffer$PointLike, endDelta?: TextBuffer$PointLike): this;
  traverse(delta: TextBuffer$PointLike): this;
  union(otherRange: TextBuffer$RangeLike): this;
}
