// @flow

declare class TextBuffer$TextBuffer {
  constructor(params: string | {
    load?: boolean;
    text?: string;
  }): this;
  addMarkerLayer(options?: {
    maintainHistory?: boolean;
  }): TextBuffer$MarkerLayer;
  append(text: string, options?: {
    normalizeLineEndings?: boolean;
    undo?: "skip" | string;
  }): TextBuffer$Range;
  backwardsScan(
    regex: RegExp,
    iterator: (event: {
      match: number; // FIXME
      matchText: string;
      range: TextBuffer$Range; // FIXME
      stop(): void;
      replace(newText: string): void;
    }) => mixed, // FIXME
  ): void;
  backwardsScanInRange(
    regex: RegExp,
    range: TextBuffer$RangeLike, // FIXME
    iterator: (event: {
      match: number; // FIXME
      matchText: string;
      range: TextBuffer$Range; // FIXME
      stop(): void;
      replace(newText: string): void;
    }) => mixed, // FIXME
  ): void;
  characterIndexForPosition(position: TextBuffer$PointLike): number;
  clearUndoStack(): void;
  clipPosition(position: TextBuffer$PointLike): TextBuffer$Point;
  clipRange(range: TextBuffer$RangeLike): TextBuffer$Range;
  createCheckpoint(): number;
  delete(range: TextBuffer$RangeLike): TextBuffer$Range;
  deleteRow(row: number): TextBuffer$Range;
  deleteRows(startRow: number, endRow: number): TextBuffer$Range;
  findMarkers(params: TextBuffer$FindMarkersOptions): TextBuffer$Marker[];
  getChangesSinceCheckpoint(checkpoint: number): Array<{
    start: TextBuffer$Point;
    oldExtent: TextBuffer$Point;
    newExtent: TextBuffer$Point;
    newText: string;
  }>;
  getDefaultMarkerLayer(): TextBuffer$MarkerLayer;
  getEncoding(): Pathwatcher$FileEncoding;
  getEndPosition(): TextBuffer$Point;
  getFirstPosition(): TextBuffer$Point & {
    column: 0;
    row: 0;
  };
  getLastLine(): string;
  getLastRow(): number;
  getLineCount(): number;
  getLines(): string[];
  getMarker(id: number): TextBuffer$Marker;
  getMarkerCount(): number;
  getMarkerLayer(id: number): TextBuffer$MarkerLayer;
  getMarkers(): TextBuffer$Marker[];
  getMaxCharacterIndex(): number;
  getPath(): string;
  getRange(): TextBuffer$Range;
  getStoppedChangingDelay(): number;
  getText(): string;
  getTextInRange(range: TextBuffer$RangeLike): string;
  getUri(): string;
  groupChangesSinceCheckpoint(checkpoint: number): boolean;
  insert(
    position: TextBuffer$PointLike,
    text: string,
    options?: {
      normalizeLineEndings?: boolean;
      undo?: "skip" | string;
    },
  ): TextBuffer$Range;
  isEmpty(): boolean;
  isInConflict(): boolean;
  isModified(): boolean;
  isRowBlank(row: number): boolean;
  lineEndingForRow(row: number): string;
  lineForRow(row: number): string;
  lineLengthForRow(row: number): number;
  markPosition(
    position: TextBuffer$PointLike,
    properties: TextBuffer$MarkerOptions,
  ): TextBuffer$Marker;
  markRange(
    range: TextBuffer$RangeLike,
    properties: TextBuffer$MarkerOptions,
  ): TextBuffer$Marker;
  nextNonBlankRow(startRow: number): null | number;
  onDidChange(callback: (event: {
    newRange: TextBuffer$Range;
    newText: string;
    oldRange: TextBuffer$Range;
    oldText: string;
  }) => mixed): EventKit$Disposable;
  onDidChangeEncoding(callback: (encoding: Pathwatcher$FileEncoding) => mixed): EventKit$Disposable;
  onDidChangeModified(callback: (modified: boolean) => mixed): EventKit$Disposable;
  onDidChangePath(callback: (path: string) => mixed): EventKit$Disposable;
  onDidConflict(callback: () => mixed): EventKit$Disposable;
  onDidCreateMarker(callback: (marker: TextBuffer$Marker) => mixed): EventKit$Disposable;
  onDidDelete(callback: () => mixed): EventKit$Disposable;
  onDidDestroy(callback: () => mixed): EventKit$Disposable;
  onDidReload(callback: () => mixed): EventKit$Disposable;
  onDidSave(callback: (event: {
    path: string;
  }) => mixed): EventKit$Disposable;
  onDidStopChanging(callback: () => mixed): EventKit$Disposable;
  onDidUpdateMarkers(callback: () => mixed): EventKit$Disposable;
  onWillChange(callback: (event : {
    newRange: TextBuffer$Range;
    newText: string;
    oldRange: TextBuffer$Range;
    oldText: string;
  }) => mixed): EventKit$Disposable;
  onWillReload(callback: () => mixed): EventKit$Disposable;
  onWillSave(callback: () => mixed): EventKit$Disposable;
  onWillThrowWatchError(callback: (errorObject: {
    error: Error; // FIXME: should refine this
    handle(): void;
  }) => mixed): EventKit$Disposable;
  positionForCharacterIndex(offset: number): TextBuffer$Point;
  previousNonBlankRow(startRow: number): null | number;
  rangeForRow(row: number, includeNewLine: boolean): TextBuffer$Range;
  redo(): boolean;
  reload(): void;
  replace(regex: RegExp, replacementText: string): number;
  revertToCheckpoint(): boolean;
  save(): void;
  saveAs(filePath: string): void;
  scan(
    regex: RegExp,
    iterator: (event: {
      match: number; // FIXME
      matchText: string;
      range: TextBuffer$Range; // FIXME
      stop(): void;
      replace(newText: string): void;
    }) => mixed,
  ): void;
  scanInRange(
    regex: RegExp,
    range: TextBuffer$Range, // FIXME
    iterator: (event: {
      match: number; // FIXME
      matchText: string;
      range: TextBuffer$Range; // FIXME
      stop(): void;
      replace(newText: string): void;
    }) => mixed,
  ): void;
  setEncoding(encoding: Pathwatcher$FileEncoding): void;
  setPath(filePath: string): void;
  setText(text: string): TextBuffer$Range;
  setTextInRange(
    range: TextBuffer$RangeLike,
    text: string,
    options?: {
      normalizeLineEndings?: boolean;
      undo?: "skip" | string;
    },
  ): TextBuffer$Range;
  setTextViaDiff(text: string): void;
  transact<T>(groupingInterval?: number, fn: () => T): void | T;
  undo(): boolean;
}
